﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
// Authors: Contino and Chen

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        string[,] formData;
        static string debug = "0";
        int[] queue;
        int current;
        int end;
        private Timer timer1; 

        //SerialPort _serialPort = new SerialPort();
        int doctorOffset = 0;
        public Form1()
        {
            InitializeComponent();
            formData = new string[25, 9];
            queue = new int[25];
            current = 0;
            end = 0;
            pictureBox1.BackgroundImageLayout = ImageLayout.Stretch;
            pictureBox2.BackColor = Color.Empty;
            pictureBox2.BackgroundImageLayout = ImageLayout.Stretch;
            pictureBox4.BackgroundImageLayout = ImageLayout.Stretch;

            serialPort1.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
            try
            {
                serialPort1.Open();

                Console.WriteLine("Press any key to continue...");
                Console.WriteLine();
                Console.Read();
                //serialPort1.Close();
                InitTimer();
            }
            catch (Exception)
            {
            }
                    

        }

        public void InitTimer()
        {
            timer1 = new Timer();
            timer1.Tick += new EventHandler(timer1_Tick);
            timer1.Interval = 500; // in miliseconds
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            parseInput();
        }

        private void parseInput()
        {
            textBox10.Text = debug;
            debug = debug.Substring(Math.Max(0, debug.Length - 1)); //how many lines is this?

        

            if (debug.Equals("4")) {
               nextPatientReady();
            } else if (debug.Equals("2")) {
                increaseTime();
            } else if (debug.Equals("3")) {
                decreaseTime();
            }

            debug = "0";
        }

        private void nextPatientReady()
        {
                formData[current, 8] = "T";
                current = (current + 1) % 25;
                int counter = 25;
                textBox10.Text = "dan";

                while ( formData[current,8] != null && formData[current, 8].Equals("T"))
                {
                    current = (current + 1) % 25;
                    counter -= 1;
                    if (counter < 0) { break; }
                }

                updateQueue();

            
  
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //textBox10.Text = debug;
            //parseInput();
            debug = "0";
            //serialPort1.Open();
            String add = "Add," + textBox1.Text + "," + end.ToString();
            serialPort1.WriteLine(add);
            //serialPort1.Close();
            formData[end, 0] = end.ToString();
            formData[end, 1] = textBox1.Text;
            formData[end, 2] = textBox2.Text;
            formData[end, 3] = textBox3.Text;
            formData[end, 4] = textBox4.Text;
            formData[end, 5] = textBox5.Text;
            formData[end, 6] = textBox6.Text;
            formData[end, 7] = textBox7.Text;
            formData[end, 8] = "F";

            textBox1.Text = "";
            textBox2.Text = "";
            textBox3.Text = "";
            textBox4.Text = "";
            textBox5.Text = "";
            textBox6.Text = "";
            textBox7.Text = "";
            end = (end + 1) % 25;
            updateQueue();
        }

        private void updateQueue()
        {
            dataGridView1.Rows.Clear();
            dataGridView1.Refresh();

            dataGridView1.ColumnCount = 2;
            dataGridView1.Columns[0].Name = "Patient Number";
            dataGridView1.Columns[1].Name = "Patient Name";

            int tempCurr = current;
            int tempEnd = end;
            int size = 0;
            while (tempCurr != tempEnd)
            {
                if (formData[tempCurr, 8].CompareTo("F") == 0)
                {
                    string[] row = new string[] { tempCurr.ToString(), formData[tempCurr, 1] };
                    dataGridView1.Rows.Add(row);
                    size++;
                }
                tempCurr = (tempCurr + 1) % 25;

            }
            label2.Text = (size * 15 + doctorOffset).ToString();

        }

        private void increaseTime()
        {
            label2.Text = (Convert.ToInt32(label2.Text) + 5).ToString();
            doctorOffset += 5;
        }

        private void decreaseTime()
        {
            int x = (Convert.ToInt32(label2.Text) - 5);
            if (x <= 0)
            {
                label2.Text = "0";
            }
            else
            {
                label2.Text = x.ToString();
            }
            doctorOffset -= 5;

        }

        private void deletePatient()
        {

        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                if (Convert.ToInt32(formData[Convert.ToInt32(textBox8.Text), 3]) == Convert.ToInt32(textBox9.Text))
                {
                    formData[Convert.ToInt32(textBox8.Text), 8] = "T";
                    if (Convert.ToInt32(textBox8.Text) == current)
                    {
                        current = (current + 1) % 25;
                    }
                    updateQueue();

                    String remove = "Remove," + formData[Convert.ToInt32(textBox8.Text), 1] + "," + formData[Convert.ToInt32(textBox8.Text), 0];
                    serialPort1.WriteLine(remove);

                    textBox8.Text = "";
                    textBox9.Text = "";
                    textBox9.BackColor = Color.White;




                }
                else
                {
                    textBox9.BackColor = Color.Red;
                }
            }
            catch (Exception)
            {
                serialPort1.Close();

            }
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {

        }

        private void write(String s)
        {
            textBox10.Text = debug;
        }

        private static void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            SerialPort sp = (SerialPort)sender;
            string indata = sp.ReadExisting();
            Console.Write("Data Received:");
            Console.Write(indata);
            debug = indata;
        }


    }
}
